;|							;;
	D C L O U D	Dynamic Cloud v.1.0		;;
	By: Andrea Andreetti	2009-01-27		;;
							|;
(princ "\nDCLOUD Dynamic Cloud v.1.0   By: Andrea Andreetti 2009-01-27")
(vl-load-com)


;;					;;
;;	DCloud Main Function		;;
;;					;;
					;;
(defun c:dcloud (/        dcmess0  dcmess1  dcmess2  dcmess3  dcmess4  dcmess5  dcmess6  snapang  drblocn  bav
                 drform   drarc    drcolor  p1       p2       p3       p4       px       fp       sp       dc_bdatax
                 dc_bitem input    bmess    p1_t     p2_t     sslist   drform   plineent haa      hab      laa
                 col      rundc
                )
  ;;	Degree Conversion	;;
  ;;
  (defun dtr (a) (* pi (/ a 180.0)))
  (defun rtd (a) (/ (* a 180) pi))
  ;;
  ;;	Degree Conversion	;;
  (defun *error* (msg)
    (princ (strcat "\n" msg))
    (dcloudfinishmode)
  )
  (vla-startundomark
    (vla-get-activedocument (vlax-get-acad-object))
  )
  (if (vl-string-search "FR" (strcase (ver)))
    (setq dcmess0 "\n(R)ectangulaire/(O)vale/(D)essiner/(L)igne ? <R>: "
          dcmess1 "\nchelle des blocs: "
          dcmess2 "\nCommencer... "
          dcmess3 "\nAppuyez sur (+) ou (-) Pour changer d'chelle... "
          dcmess4 "\nCouleurs alatoires ? Oui/Non <N>: "
          dcmess5 "\nNom du bloc : "
          dcmess6 "\nBloc non trouv !"
    )
    (setq dcmess0 "\n(R)ectangular/(O)val/(D)raw/(L)ine ? <R>: "
          dcmess1 "\nBlock scale: "
          dcmess2 "\nStart... "
          dcmess3 "\nPress (+) or (-) for Block Scale... "
          dcmess4 "\nRanDom Color ? Yes/No <N>: "
          dcmess5 "\nBlock Name : "
          dcmess6 "\nBlock not found !"
    )
  )
  (setq snapang (getvar "snapang"))
  (setq drblocn (strcase (getstring dcmess5 t)))
  (setq bav (mapcar 'strcase (ai_table "BLOCK" 4)))
  (while (not (or (member drblocn bav) (findfile drblocn)))
    (princ dcmess6)
    (setq drblocn (strcase (getstring dcmess5 t)))
  )
  (initget "R O L D")
  (setq drform (getkword dcmess0))
  (if (not drform)
    (setq drform "R")
  )
  (while (< drarc 0) (setq drarc (getreal dcmess1)))
  (initget "Y N O")
  (setq drcolor (getkword dcmess4))
  (if (and drcolor (/= drcolor "N"))
    (setq col 1)
    ;;add color
    (setq col nil)
  )
  (setq p1 (getpoint dcmess2))
  (setq basep p1)
  (setvar "CMDECHO" 0)
  (vl-cmdf "._-insert" drblocn p1 "" "" "")
  (setq dc_bdatax (entget (setq dc_bitem (entlast))))
  (if dc_bitem
    (progn (vl-cmdf "._erase" dc_bitem "") (setq dc_bitem nil))
  )
  (setq rundc t)
  (setq bmess nil)
  (dcwhile p1)
)
					;;
;;					;;
;;	DCloud Main Function		;;
;;					;;








;;					;;
;;	DCloud While Loop		;;
;;					;;
					;;
(defun dcwhile (p1)
  (setq bqt 0)
  (while (and rundc
              (or (and (setq input (grread t 4 4)) (= (car input) 5))
                  (and (= (car input) 2) (= (cadr input) 61)) ;= as +
                  (and (= (car input) 2) (= (cadr input) 45)) ;-
                  (and (= (car input) 2) (= (cadr input) 43)) ;+
              )
         )
    (if (not bmess)
      (princ dcmess3)
    )
    (setq bmess t)
    (if (= (car input) 5)
      (progn (setq dcdist (/ (distance p1 (setq px (cadr input))) drarc))
             (if (eq dcdist 0)
               (setq dcdist 1)
             )
             (setq p3 px)
             (setq p2_t (polar p3 (- snapang (dtr 90)) 3))
             (setq p1_t (polar p1 snapang 3))
             (setq p2 (inters p1 p1_t p3 p2_t nil))
             (setq p4 (polar p1 (angle p2 p3) (distance p2 p3)))
      )
    )
    (if (or (and (= (car input) 2) (= (cadr input) 61)) ;= as +
            (and (= (car input) 2) (= (cadr input) 43)) ;+
        )
      (setq drarc (1+ drarc))
    )
    (if (and (= (car input) 2) (= (cadr input) 45)) ;-
      (if (> drarc 1)
        (setq drarc (1- drarc))
      )
    )
    (dccleanentity)
    (if (and p1 p2 p3 p4)
      (progn (dccleanentity)
             ;;Rectangular or Oval
             (if (or (= drform "R") (= drform "O"))
               (progn (vl-cmdf "._pline" "_non" p1 "_non" p2 "_non" p3 "_non" p4 "_C")
                      (setq plineent (entlast))
                      (if (eq drform "O")
                        (vl-cmdf "._pedit" plineent "_S" "")
                      )
                      (if plineent
                        (progn (dcgetpointslist (vlax-ename->vla-object plineent) dcdist)
                               (if plineent
                                 (progn (vl-cmdf "._erase" plineent "") (setq plineent nil))
                               )
                               (if (and drcolor (/= drcolor "N"))
                                 (setq col 1)
                                 ;;add color
                                 (setq col nil)
                               )
                               (if (> (distance p1 p2) 1)
                                 (progn (setq fp (car pt-list))
                                        (foreach sp (cdr pt-list)
                                          (if (> (distance fp sp) 0.1)
                                            (progn (dcinsertblock drblocn
                                                                  fp
                                                                  (distance fp sp)
                                                                  (distance fp sp)
                                                                  (angle fp sp)
                                                                  col
                                                   )
                                                   (setq fp sp)
                                            )
                                          )
                                          (if col
                                            (if (> col 254)
                                              (setq col 0)
                                              (setq col (1+ col))
                                            )
                                          )
                                        )
                                        (if (> (distance fp (car pt-list)) 0)
                                          (dcinsertblock drblocn
                                                         fp
                                                         (distance fp (car pt-list))
                                                         (distance fp (car pt-list))
                                                         (angle fp (car pt-list))
                                                         col
                                          )
                                        )
                                 )
                               )
                        )
                        (princ)
                      )
               ) ;_progn
             )
             ;;LINE
             (if (= drform "L")
               (progn (setq pt-list nil)
                      (setq dcdistl (/ (distance p1 px) drarc))
                      (setq fp p1)
                      (repeat (fix dcdistl)
                        (setq pt-list (append pt-list
                                              (list (setq fp (polar fp (angle fp px) drarc)))
                                      )
                        )
                      )
                      (setq pt-list (append pt-list (list px)))
                      (if (and drcolor (/= drcolor "N"))
                        (setq col 1)
                        ;;add color
                        (setq col nil)
                      )
                      (setq fp p1)
                      (foreach sp pt-list
                        (if (/= (distance fp sp) 0)
                          (progn (dcinsertblock drblocn
                                                fp
                                                (distance fp sp)
                                                (distance fp sp)
                                                (angle fp sp)
                                                col
                                 )
                                 (setq fp sp)
                                 (if col
                                   (if (> col 254)
                                     (setq col 0)
                                     (setq col (1+ col))
                                   )
                                 )
                          )
                        )
                      )
               )
             )
             ;;Draw
             (if (= drform "D")
               (progn (setq fp p1)
                      (if (/= (distance fp px) 0)
                        (dcinsertblock drblocn
                                       fp
                                       (distance fp px)
                                       (distance fp px)
                                       (angle fp px)
                                       col
                        )
                      )
                      (if (and (> bqt 2) (< (distance px basep) drarc))
                        (progn (dccleanentity)
                               (dcinsertblock drblocn fp drarc drarc (angle fp basep) col)
                               (setq fp (polar fp (angle fp basep) drarc))
                               (dcinsertblock drblocn
                                              fp
                                              (distance fp basep)
                                              (distance fp basep)
                                              (angle fp basep)
                                              col
                               )
                               (setq sslist nil)
                               (setq drform nil)
                               (setq rundc nil)
                        )
                        (if (> (distance fp px) drarc)
                          (progn (if sslist
                                   (progn (foreach n sslist (vl-cmdf "._erase" n ""))
                                          (setq sslist nil)
                                   )
                                 )
                                 (setq bqt (1+ bqt))
                                 (dcinsertblock drblocn fp drarc drarc (angle fp px) col)
                                 (setq p1 (polar fp (angle fp px) drarc))
                                 (setq sslist nil)
                                 (if col
                                   (if (> col 254)
                                     (setq col 0)
                                     (setq col (1+ col))
                                   )
                                 )
                          )
                        )
                      )
               )
             )
      )
    )
  )
  (if (= drform "L")
    (progn (if (= (car input) 3)
             (progn (setq sslist nil) (setq plineent nil) (dcwhile p3))
           )
           (if (= (car input) 25)
             (dccleanentity)
           )
    )
  )
  (vla-endundomark
    (vla-get-activedocument (vlax-get-acad-object))
  )
)
					;;
;;					;;
;;	DCloud While Loop		;;
;;					;;







;;					;;
;;	DCloud Clead entity		;;
;;					;;
					;;
(defun dccleanentity ()
  (if sslist
    (progn (foreach n sslist (vl-cmdf "._erase" n ""))
           (setq sslist nil)
    )
  )
)
					;;
;;					;;
;;	DCloud Clead entity		;;
;;					;;







;;					;;
;;	DCloud Block creation		;;
;;					;;
					;;
(defun dcinsertblock (bname ip dx dy an coul / bent)
  (setq dc_bdatax (subst (cons 2 bname) (assoc 2 dc_bdatax) dc_bdatax))
  (setq dc_bdatax (subst (cons 10 ip) (assoc 10 dc_bdatax) dc_bdatax))
  (setq dc_bdatax (subst (cons 41 dx) (assoc 41 dc_bdatax) dc_bdatax))
  (setq dc_bdatax (subst (cons 42 dy) (assoc 42 dc_bdatax) dc_bdatax))
  (setq dc_bdatax (subst (cons 50 an) (assoc 50 dc_bdatax) dc_bdatax))
  (if coul
    (if (not (assoc 62 dc_bdatax))
      (setq dc_bdatax (append dc_bdatax (list (cons 62 coul))))
      (setq dc_bdatax (subst (cons 62 coul) (assoc 62 dc_bdatax) dc_bdatax))
    )
  )
  (entmake dc_bdatax)
  (setq bent (entlast))
  (setq sslist (append sslist (list bent)))
)
					;;
;;					;;
;;	DCloud Block creation		;;
;;					;;






;;					;;
;;	DCloud Block creation		;;
;;					;;
					;;
(defun dcgetpointslist (pline-vla nb-seg)
  (if (or (eq (vla-get-objectname pline-vla) "AcDbPolyline")
          (eq (vla-get-objectname pline-vla) "AcDb2dPolyline")
      )
    (progn (setq seg-long (/ (vla-get-length pline-vla) nb-seg))
           (setq end-pt (vlax-curve-getendpoint pline-vla))
    )
  )
  (setq start-pt (vlax-curve-getstartpoint pline-vla))
  (setq pt-list (list start-pt))
  (setq n 1)
  (while (<= n nb-seg)
    (setq pt-list (append pt-list
                          (list
                            (setq sp (vlax-curve-getpointatdist pline-vla (* seg-long n)))
                          )
                  )
    )
    (setq n (1+ n))
  )
)
					;;
;;					;;
;;	DCloud Block creation		;;
;;					;;





;;					;;
;;	DCloud Block Finish Mode	;;
;;					;;
					;;
(defun DCloudFinishMode ()
(dccleanentity)  
(setq VarLst '(dcmess0 dcmess1  dcmess2  dcmess3  dcmess4  dcmess5  dcmess6  snapang  drblocn  bav      drform
                       drarc    drcolor  p1       p2       p3       p4       px       fp       sp       dc_bdatax
                       dc_bitem input    bmess    p1_t     p2_t     sslist   drform   plineent haa      hab
                       laa      col      rundc
                      ))
(mapcar '(lambda (l) (set l nil)) VarLst)
)
					;;
;;					;;
;;	DCloud Block Finish Mode	;;
;;					;;
;|Visual LISP Format Options
(120 2 1 2 nil "Ende von " 60 20 1 1 0 nil nil nil T)
;*** DO NOT add text below the comment! ***|;
